OpenCV: cvflann::LshIndex< Distance > Class Template Reference

| OpenCV 3.4.2 Open Source Computer Vision

Classes | Public Types | Public Member Functions | List of all members
cvflann::LshIndex< Distance > Class Template Reference

`#include "lsh_index.h"`

Inheritance diagram for cvflann::LshIndex< Distance >:

## Public Types
typedef Distance::ResultType | DistanceType
typedef Distance::ElementType | ElementType

## Public Member Functions
| LshIndex (const Matrix< ElementType > &input_data, const IndexParams &params=LshIndexParams(), Distance d=Distance())
| LshIndex (const LshIndex &)
void | buildIndex () CV_OVERRIDE
void | findNeighbors (ResultSet< DistanceType > &result, const ElementType *vec, const SearchParams &) CV_OVERRIDE
IndexParams | getParameters () const CV_OVERRIDE
flann_algorithm_t | getType () const CV_OVERRIDE
virtual void | knnSearch (const Matrix< ElementType > &queries, Matrix< int > &indices, Matrix< DistanceType > &dists, int knn, const SearchParams &params) CV_OVERRIDE
| Perform k-nearest neighbor search. More...
void | loadIndex (FILE *stream) CV_OVERRIDE
| Loads the index from a stream. More...
LshIndex & | operator= (const LshIndex &)
void | saveIndex (FILE *stream) CV_OVERRIDE
| Saves the index to a stream. More...
size_t | size () const CV_OVERRIDE
int | usedMemory () const CV_OVERRIDE
size_t | veclen () const CV_OVERRIDE
Public Member Functions inherited from cvflann::NNIndex< Distance >
virtual | ~NNIndex ()
virtual int | radiusSearch (const Matrix< ElementType > &query, Matrix< int > &indices, Matrix< DistanceType > &dists, float radius, const SearchParams &params)
| Perform radius search. More...

## Detailed Description

### template<typename Distance>
class cvflann::LshIndex< Distance >

Randomized kd-tree index

Contains the k-d trees and other information for indexing a set of points for nearest-neighbor matching.

## Member Typedef Documentation

## ◆ DistanceType

template<typename Distance>

typedef Distance::ResultType cvflann::LshIndex< Distance >::DistanceType

## ◆ ElementType

template<typename Distance>

typedef Distance::ElementType cvflann::LshIndex< Distance >::ElementType

## Constructor & Destructor Documentation

## ◆ LshIndex() [1/2]

template<typename Distance>

cvflann::LshIndex< Distance >::LshIndex | ( | const Matrix< ElementType > & | input_data,
|  | const IndexParams & | params = `LshIndexParams()`,
|  | Distance | d = `Distance()`
| ) |  |
| inline

Constructor

Parameters

  input_data | dataset with the input features
  params | parameters passed to the LSH algorithm
  d | the distance used

## ◆ LshIndex() [2/2]

template<typename Distance>

cvflann::LshIndex< Distance >::LshIndex | ( | const LshIndex< Distance > & |  | ) |

## Member Function Documentation

## ◆ buildIndex()

template<typename Distance>

void cvflann::LshIndex< Distance >::buildIndex | ( |  | ) |
| inlinevirtual

Builds the index

Implements cvflann::NNIndex< Distance >.

## ◆ findNeighbors()

template<typename Distance>

void cvflann::LshIndex< Distance >::findNeighbors | ( | ResultSet< DistanceType > & | result,
|  | const ElementType * | vec,
|  | const SearchParams & |
| ) |  |
| inlinevirtual

Find set of nearest neighbors to vec. Their indices are stored inside the result object.

Params: result = the result object in which the indices of the nearest-neighbors are stored vec = the vector for which to search the nearest neighbors maxCheck = the maximum number of restarts (in a best-bin-first manner)

Implements cvflann::NNIndex< Distance >.

## ◆ getParameters()

template<typename Distance>

IndexParams cvflann::LshIndex< Distance >::getParameters | ( |  | ) | const
| inlinevirtual

Returns
  The index parameters

Implements cvflann::NNIndex< Distance >.

## ◆ getType()

template<typename Distance>

flann_algorithm_t cvflann::LshIndex< Distance >::getType | ( |  | ) | const
| inlinevirtual

Returns
  The index type (kdtree, kmeans,...)

Implements cvflann::NNIndex< Distance >.

## ◆ knnSearch()

template<typename Distance>

virtual void cvflann::LshIndex< Distance >::knnSearch | ( | const Matrix< ElementType > & | queries,
|  | Matrix< int > & | indices,
|  | Matrix< DistanceType > & | dists,
|  | int | knn,
|  | const SearchParams & | params
| ) |  |
| inlinevirtual

Perform k-nearest neighbor search.

Parameters

  [in] | queries | The query points for which to find the nearest neighbors
  [out] | indices | The indices of the nearest neighbors found
  [out] | dists | Distances to the nearest neighbors found
  [in] | knn | Number of nearest neighbors to return
  [in] | params | Search parameters

Reimplemented from cvflann::NNIndex< Distance >.

## ◆ loadIndex()

template<typename Distance>

void cvflann::LshIndex< Distance >::loadIndex | ( | FILE * | stream | ) |
| inlinevirtual

Loads the index from a stream.

Parameters

  stream | The stream from which the index is loaded

Implements cvflann::NNIndex< Distance >.

## ◆ operator=()

template<typename Distance>

LshIndex& cvflann::LshIndex< Distance >::operator= | ( | const LshIndex< Distance > & |  | ) |

## ◆ saveIndex()

template<typename Distance>

void cvflann::LshIndex< Distance >::saveIndex | ( | FILE * | stream | ) |
| inlinevirtual

Saves the index to a stream.

Parameters

  stream | The stream to save the index to

Implements cvflann::NNIndex< Distance >.

## ◆ size()

template<typename Distance>

size_t cvflann::LshIndex< Distance >::size | ( |  | ) | const
| inlinevirtual

Returns size of index.

Implements cvflann::NNIndex< Distance >.

## ◆ usedMemory()

template<typename Distance>

int cvflann::LshIndex< Distance >::usedMemory | ( |  | ) | const
| inlinevirtual

Computes the index memory usage Returns: memory used by the index

Implements cvflann::NNIndex< Distance >.

## ◆ veclen()

template<typename Distance>

size_t cvflann::LshIndex< Distance >::veclen | ( |  | ) | const
| inlinevirtual

Returns the length of an index feature.

Implements cvflann::NNIndex< Distance >.

The documentation for this class was generated from the following file:

- flann/include/opencv2/flann/lsh_index.h